version: "3"

services:
  zookeeper:
    image: confluentinc/cp-zookeeper:7.0.0
    hostname: zookeeper
    ports:
      - "2181:2181"
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_TICK_TIME: 2000

  kafka:
    image: confluentinc/cp-kafka:7.0.0
    hostname: kafka
    depends_on:
      - zookeeper
    ports:
      - "29092:29092"
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:2181
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: PLAINTEXT:PLAINTEXT,PLAINTEXT_HOST:PLAINTEXT
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://kafka:9092,PLAINTEXT_HOST://localhost:29092
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_GROUP_INITIAL_REBALANCE_DELAY_MS: 0
      KAFKA_TRANSACTION_STATE_LOG_MIN_ISR: 1
      KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR: 1
      KAFKA_CREATE_TOPICS: "messages"

  kafka-ui:
    image: provectuslabs/kafka-ui:latest
    ports:
      - "8080:8080"
    depends_on:
      - kafka
    environment:
      KAFKA_CLUSTERS_0_NAME: local
      KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS: kafka:9092
      # KAFKA_CLUSTERS_0_ZOOKEEPER: zookeeper:2181

  topic-init:
    build:
      context: .
      dockerfile: Dockerfile.init
    depends_on:
      - kafka
    command:
      - /bin/bash
      - -c
      - |
        wait-for-it kafka:9092
        cat /data/message.json | kaf produce messages

  appio-proxy:
    build: .
    environment:
      APPIO_ENDPOINT: https://apigw-staging.055055.it/postmsg
      KAFKA_BOOTSTRAP_SERVERS: kafka:9092
      KAFKA_TOPIC_NAME: messages
      KAFKA_GROUP_ID: appio-proxy
      SDC_AUTH_TOKEN_USER: admin
      SDC_AUTH_TOKEN_PASSWORD: admin
      #STORAGE_TYPE: "MINIO"
      STORAGE_KEY: "/"
      #STORAGE_KEY: "AKIAIOSFODNN7EXAMPLE"
      #STORAGE_SECRET: "wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY"
      STORAGE_BUCKET_NAME: "appio"
      #STORAGE_ENDPOINT: "minio:9000"
    volumes:
      - ./configs/config.json:/appio/config.json
    depends_on:
      - kafka

  minio:
    image: minio/minio
    command: server /data --console-address ":9001"
    restart: unless-stopped
    volumes:
      - ./bucket:/data
    ports:
      - 9000:9000
      - 9001:9001
    environment:
      MINIO_ACCESS_KEY: AKIAIOSFODNN7EXAMPLE
      MINIO_SECRET_KEY: wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY

  createbuckets:
    image: minio/mc
    depends_on:
      - minio
    entrypoint: >
        /bin/sh -c "
        while ! /usr/bin/mc config host add minio http://minio:9000 AKIAIOSFODNN7EXAMPLE wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY;
        do echo Wait minio to startup... && sleep 0.1; done;
        /usr/bin/mc mb minio/appio;
        /usr/bin/mc policy set public minio/appio;
        exit 0;
        "
